package org.japura.controller;

import java.util.List;

/**
 * <P>
 * Copyright (C) 2013 Carlos Eduardo Leite de Andrade
 * <P>
 * This library is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * <P>
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * <P>
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <A
 * HREF="www.gnu.org/licenses/">www.gnu.org/licenses/</A>
 * <P>
 * For more information, contact: <A HREF="www.japura.org">www.japura.org</A>
 * <P>
 * 
 * @author Carlos Eduardo Leite de Andrade
 */
public interface ControllerManager{

  public void addListener(ControllerManagerListener listener);

  public void removeListener(ControllerManagerListener listener);

  public List<ControllerManagerListener> getListeners();

  public boolean existsLink(ControllerModel controller1,
							ControllerModel controller2);

  public boolean existsLink(ControllerModel controller, Class<?> clss);

  public void link(ControllerModel controller1, ControllerModel controller2);

  public void unlink(ControllerModel controller1, ControllerModel controller2);

  public void remove(String id);

  public void remove(String id, boolean cancelTaskExecution);

  public void removeGroup(String groupdId);

  public void removeAll(Class<?> clss);

  public void removeAllFromGroup(String groupId, Class<?> clss);

  public boolean isInstancied(Class<?> clss);

  public boolean isInstanciedInGroup(String groupId, Class<?> clss);

  public void removeAll();

  public int count(Class<?> clss);

  public <E> E get(Class<E> clss);

  public Class<?> getNewInstanceClass();

  public <E> E newInstance(Class<E> clss);

  public <E> E get(String id, Class<E> clss);

  public <E> E getFromGroup(String groupId, Class<E> clss);

  public <E> E getFromGroup(String groupId, String id, Class<E> clss);

  public ControllerModel getFromGroup(String groupId, String id);

  public <E> List<E> getAllFromGroup(String groupId, Class<E> clss);

  public List<ControllerModel> getAllFromGroup(String groupId);

  public ControllerModel get(String id);

  public <E> List<E> getAll(Class<E> clss);

  public List<ControllerModel> getAll();

  public boolean contains(ControllerModel controller);

  public void printAllControllers();

  public ControllerModel getRoot(String groupId);

  public <E> E getFromLink(ControllerModel controllerInLink, Class<E> clss);

  public void remove(ControllerModel controller, boolean cancelTaskExecution);

  public void closeModal(ControllerModel model);

  public void updateDebugComponents();

  public void removeFromDebugComponents(ControllerModel controller);

  public void unlink(ControllerModel controller);

  public void fetchHierarchy(ControllerModel parentController,
							 List<ControllerModel> list);

  public void add(ControllerModel controller);

  public void publishToAll(Message message);

  public boolean acceptsMessage(ControllerModel controller, Message message);

}
