package org.japura.debug;

import java.util.ArrayList;
import java.util.List;

import javax.swing.JPanel;

import org.japura.util.WeakList;

/**
 * 
 * Copyright (C) 2011 Carlos Eduardo Leite de Andrade
 * <P>
 * This library is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option) any
 * later version.
 * <P>
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * <P>
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program. If not, see <A
 * HREF="www.gnu.org/licenses/">www.gnu.org/licenses/</A>
 * <P>
 * For more information, contact: <A HREF="www.japura.org">www.japura.org</A>
 * <P>
 * 
 * @author Carlos Eduardo Leite de Andrade
 * 
 */
public abstract class DebugComponent extends JPanel{

  private static WeakList<DebugComponent> components =
	  new WeakList<DebugComponent>();

  public static synchronized boolean exists(Class<?> clss) {
	for (DebugComponent db : components) {
	  if (db.getClass().equals(clss)) {
		return true;
	  }
	}
	return false;
  }

  public static synchronized List<DebugResult> publish(Class<?> clss,
													   DebugParameter parameter) {
	List<DebugResult> results = new ArrayList<DebugResult>();
	for (DebugComponent db : components) {
	  if (db.getClass().equals(clss)) {
		DebugResult result = db.update(parameter);
		if (result != null) {
		  results.add(result);
		}
	  }
	}
	DebugWindow.updateTabTitles();
	return results;
  }

  public static synchronized void add(DebugComponent component) {
	components.add(component);
  }

  protected abstract DebugResult update(DebugParameter parameter);

  protected abstract String getTitle();

}
